<?php

/* ====================
Land Down Under - Website engine
Copyright Neocrome
http://www.neocrome.net

[BEGIN_LDU]
File=googlesitemap.php
Version=802
Updated=28-04-2006
Type=Core
Author=CTAPbIu_MABP
Description=
[END_LDU]
==================== */

define('SED_CODE', TRUE);
$location = "GSM";

require('system/functions.php');
require('system/templates.php');
require('datas/config.php');
require('system/common.php');

/*
Google Site Map 0.81 Generator
For more information visit http://www.google.com/webmasters/sitemaps/docs/en/protocol.html
Google is a guest so have a guest rights
Charset UTF-8 ONLY!!!
*/

$GSM['pages']['changefreq']  = "daily"; // [str] (always/hourly/daily/weekly/monthly/yearly/never)
$GSM['pages']['priority']    = "0.8";   // [str] (default: 0.5)
$GSM['pages']['limit']       = 100;     // [int] (don't use more then 200)
$GSM['pages']['structure']   = "1";     // [str] (structure like articles 1.2.3 , without dot in the end)

$GSM['news']['changefreq']   = "daily";
$GSM['news']['priority']     = "0.6";
$GSM['news']['limit']        = 100;
$GSM['news']['structure']    = "8";

$GSM['events']['changefreq'] = "daily";
$GSM['events']['priority']   = "0.6";
$GSM['events']['limit']      = 100;
$GSM['events']['structure']  = "7";

$GSM['lists']['changefreq']  = "weekly";
$GSM['lists']['priority']    = "0.5";
$GSM['lists']['limit']       = 100;

$GSM['index']['changefreq']  = "always";
$GSM['index']['priority']    = "1.0";


$GSM['forums']['changefreq'] = "daily";
$GSM['forums']['priority']   = "0.2";
$GSM['forums']['limit']      = 100;


// journals, blogs and other publications you can make yourself by copy/past/change

$sys['now'] = time();
$m = sed_import('m','G','ALP'); // (index/lists/pages/news/events)

if (isset($GSM[$m]))
{
        $feed .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"; // UTF-8 only! read manual!!!
        $feed .= "<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n"; // current version
}

switch ($m)
{
case 'index':
        // index page
        $feed .= "<url>\n";
        $feed .= "<loc>".$cfg['mainurl']."/</loc>\n";
        $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $sys['now'])."</lastmod>\n";
        $feed .= "<changefreq>".$GSM['index']['changefreq']."</changefreq>\n";
        $feed .= "<priority>".$GSM['index']['priority']."</priority>\n";
        $feed .= "</url>\n";
        break;

case 'lists':
        // list of all cat's
        $sql = sed_sql_query("SELECT structure_code FROM sed_structure ORDER BY structure_path ASC");
        while($listrow = sed_sql_fetchassoc($sql))
        {
                $feed .= "<url>\n";
                $feed .= "<loc>".$cfg['mainurl']."/list/".$listrow['structure_code']."/</loc>\n";
                $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $sys['now'])."</lastmod>\n";
                $feed .= "<changefreq>".$GSM['lists']['changefreq']."</changefreq>\n";
                $feed .= "<priority>".$GSM['lists']['priority']."</priority>\n";
                $feed .= "</url>\n";
        }
        break;

case 'pages':
        // list of all articles
        $sql = sed_sql_query("SELECT p.page_id, p.page_alias, p.page_date, p.page_cat FROM sed_pages p LEFT JOIN sed_structure s ON (p.page_cat=s.structure_code) WHERE (page_state = 0 OR page_state = 2) AND structure_path REGEXP '^{$GSM['pages']['structure']}' ORDER BY page_date DESC LIMIT ".$GSM['pages']['limit']);
        while($pagerow = sed_sql_fetchassoc($sql))
        {
                list($usr['auth_read'], $usr['auth_write'], $usr['isadmin']) = sed_auth('page', $pagerow['page_cat']);
                if($usr['auth_read'])
                {
                        $feed .= "<url>\n";
                        $feed .= "<loc>".$cfg['mainurl']."/page/".(($pagerow['page_alias'])?$pagerow['page_alias']:$pagerow['page_id'])."/</loc>\n";
                        $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $pagerow['page_date'])."</lastmod>\n";
                        $feed .= "<changefreq>".$GSM['pages']['changefreq']."</changefreq>\n";
                        $feed .= "<priority>".$GSM['pages']['priority']."</priority>\n";
                        $feed .= "</url>\n";
                }
        }
        break;

case 'news':
        // list of all news
        $sql = sed_sql_query("SELECT p.page_id, p.page_alias, p.page_date, p.page_cat FROM sed_pages p LEFT JOIN sed_structure s ON (p.page_cat=s.structure_code) WHERE (page_state = 0 OR page_state = 2) AND structure_path REGEXP '^{$GSM['news']['structure']}' ORDER BY page_date DESC LIMIT ".$GSM['news']['limit']);
        while($pagerow = sed_sql_fetchassoc($sql))
        {
                list($usr['auth_read'], $usr['auth_write'], $usr['isadmin']) = sed_auth('page', $pagerow['page_cat']);
                if($usr['auth_read'])
                {
                        $feed .= "<url>\n";
                        $feed .= "<loc>".$cfg['mainurl']."/page/".(($pagerow['page_alias'])?$pagerow['page_alias']:$pagerow['page_id'])."/</loc>\n";
                        $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $pagerow['page_date'])."</lastmod>\n";
                        $feed .= "<changefreq>".$GSM['news']['changefreq']."</changefreq>\n";
                        $feed .= "<priority>".$GSM['news']['priority']."</priority>\n";
                        $feed .= "</url>\n";
                }
        }
        break;

case 'events':
        // list of all events
        $sql = sed_sql_query("SELECT p.page_id, p.page_alias, p.page_date, p.page_cat FROM sed_pages p LEFT JOIN sed_structure s ON (p.page_cat=s.structure_code) WHERE (page_state = 0 OR page_state = 2) AND structure_path REGEXP '^{$GSM['events']['structure']}' ORDER BY page_date DESC LIMIT ".$GSM['events']['limit']);
        while($pagerow = sed_sql_fetchassoc($sql))
        {
                list($usr['auth_read'], $usr['auth_write'], $usr['isadmin']) = sed_auth('page', $pagerow['page_cat']);
                if($usr['auth_read'])
                {
                        $feed .= "<url>\n";
                        $feed .= "<loc>".$cfg['mainurl']."/page/".(($pagerow['page_alias'])?$pagerow['page_alias']:$pagerow['page_id'])."/</loc>\n";
                        $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $pagerow['page_date'])."</lastmod>\n";
                        $feed .= "<changefreq>".$GSM['events']['changefreq']."</changefreq>\n";
                        $feed .= "<priority>".$GSM['events']['priority']."</priority>\n";
                        $feed .= "</url>\n";
                }
        }
        break;
/*
case 'forums':
        // list of latest updated topics
        $sql = sed_sql_query("SELECT t.ft_id, t.ft_movedto, s.fs_id, p.fp_updated FROM sed_forum_posts p LEFT JOIN sed_forum_topics t ON ( p.fp_topicid = t.ft_id ) LEFT JOIN sed_forum_sections s ON ( p.fp_sectionid = s.fs_id ) GROUP BY t.ft_id ORDER BY t.ft_sticky DESC, p.fp_creation DESC LIMIT ".$GSM['forums']['limit']);

        while($forumrow = sed_sql_fetchassoc($sql))
        {
                list($usr['auth_read'], $usr['auth_write'], $usr['isadmin']) = sed_auth('forums', $forumrow['fs_id']);
                if($usr['auth_read'])
                {
                        $feed .= "<url>\n";
                        $feed .= "<loc>".$cfg['mainurl']."/forums.php?m=posts&q=".(($forumrow['ft_movedto'])?$forumrow['ft_movedto']:$forumrow['ft_id'])."</loc>\n";
                        $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $forumrow['fp_updated'])."</lastmod>\n";
                        $feed .= "<changefreq>".$GSM['events']['changefreq']."</changefreq>\n";
                        $feed .= "<priority>".$GSM['events']['priority']."</priority>\n";
                        $feed .= "</url>\n";
                }
        }
        break
*/
default:
        // site map index by default
        $feed .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
        $feed .= "<sitemapindex xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";
        foreach($GSM as $key => $value)
        {
                $feed .= "<sitemap>\n";
                $feed .= "<loc>".$cfg['mainurl']."/googlesitemap.php?m=$key</loc>\n";
                $feed .= "<lastmod>".@date("Y-m-d\TH:i:s+00:00", $sys['now'])."</lastmod>\n";
                $feed .= "</sitemap>\n";
        }
        $feed .= "</sitemapindex>\n";
        break;
}

if (isset($GSM[$m])){
        $feed .= "</urlset>";
}

function miscGzHandler($buf) {
    $zipRatio = 5;    // 0 <= zipRatio <= 9 depends of your server
    $bufZiped = gzcompress($buf, $zipRatio);
    $bufZiped = pack('cccccccc',0x1f,0x8b,0x08,0x00,0x00,0x00,0x00,0x00)
        .substr($bufZiped, 0, -4)
        .pack('V',crc32($buf))
        .pack('V',strlen($buf));
        header('Content-description: File Transfer');
        header('Content-type: application/x-gzip');
    header('Content-encoding: gzip/x-gzip');
    header('Content-length: '.strlen($bufZiped));
        header("Content-Disposition: attachment; filename=googlesitemap.xml.gz");
    return $bufZiped;
}

@ob_start('miscGzHandler');
echo(utf8_encode($feed));
@ob_end_flush(); // miscGzHandler

?>